!
Subroutine LSQ_Solver
use Advertisement
use IMSLF90
integer*4 i
complex*16 r_p(2*n_max,1), sol(2*l_max,1)
if (m.eq.0) then
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_M(2,i)
 end do
 call lin_sol_lsq(MATRIX(1:n_max, 1:l_max), r_p, sol)
 do i=1, l_max
  l_M(2,i)=sol(i,1)
 end do
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_N(2,i)
 end do
 call lin_sol_lsq(MATRIX(n_max+1:2*n_max, l_max+1:2*l_max), r_p, sol)
 do i=1, l_max
  l_N(2,i)=sol(i,1)
 end do
else
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_M(2,i)
  r_p(n_max+i,1)=n_N(3,i)
 end do
 call lin_sol_lsq(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol)
 do i=1, l_max
  l_M(2,i)=sol(i,1) !; print *, l_M(2, i) !
  l_N(3,i)=sol(i+l_max,1) !; print *, l_N(3, i) !
 end do
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_M(3,i)
  r_p(n_max+i,1)=n_N(2,i)
 end do
 do n=1, n_max
  do l=1, l_max
   MATRIX(n, l_max+l)=-MATRIX(n, l_max+l)
   MATRIX(n_max+n, l)=-MATRIX(n_max+n, l)
  end do
 end do
 call lin_sol_lsq(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol)
 do i=1, l_max
  l_M(3,i)=sol(i,1)     !; print *, l_M(3, i) !
  l_N(2,i)=sol(i+l_max,1) !; print *, l_N(2, i) !
 end do
end if
End Subroutine LSQ_Solver